app/auth.py
#!/usr/bin/env python3
# -*- encoding: utf-8 -*-
"""
Flask + Python3 application template
Author: Frederico Freire Boaventura <frederico@boaventura.net>
URL: https://gitlab.com/ffb-portfolio/websites/flask-boilerplate
     https://github.com/fboaventura/flask-boilerplate
Licence: GPLv3
"""

import os
from flask import Blueprint, render_template, redirect, url_for, request, flash
from werkzeug.security import generate_password_hash, check_password_hash
from flask_login import login_user, logout_user, current_user, login_required
from flask_babel import ngettext
from flask_babel import gettext as _
from .models import User
from . import db

auth = Blueprint('auth', __name__)


@auth.route('/login')
def login():
    return render_template('auth/login.html')


@auth.route('/login', methods=['POST'])
def login_post():
    email = request.form.get('email')
    password = request.form.get('password')
    remember = True if request.form.get('remember') else False
    
    user = User.query.filter_by(email=email).first()
    
    # Check if user exists
    # take the user supplied password, hash it, and compare with the hashed password in database
    if not user or not check_password_hash(user.password, password):
        flash(_(u'Please check your login details and try again.'), 'danger')
        return redirect(url_for('auth.login'))  # if user doesn't exist or password is wrong, reload the page
    
    # if the above check passes, then proceed with user login
    login_user(user, remember=remember)
    return redirect(url_for('index'))


@auth.route('/signup')
def signup():
    return render_template('auth/signup.html')


@auth.route('/signup', methods=['POST'])
def signup_post():
    email = request.form.get('email')
    name = request.form.get('name')
    password = request.form.get('password')
    
    user = User.query.filter_by(email=email).first()  # if this returns true, then the e-mail is already in the database
    
    if user:
        flash(_(u'Email address already exists'), 'danger')
        return redirect(url_for('auth.signup'))
    
    # create new user with data provided by the form. Hash the password to save it into the database
    new_user = User(email=email, name=name, password=generate_password_hash(password, method='sha256'))
    
    # add new user to the database
    db.session.add(new_user)
    db.session.commit()
    
    return redirect(url_for('auth.login'))


@auth.route('/logout')
@login_required
def logout():
    logout_user()
    return redirect(url_for('main.index'))


# @auth.route('/new/')
# @login_required
# def new():
#     form = ExampleForm()
#     return render_template('new.html', form=form)
# 
# 
# @auth.route('/save/', methods=['GET', 'POST'])
# @login_required
# def save():
#     form = ExampleForm()
#     if form.validate_on_submit():
#         print("Saving data...")
#         print(form.title.data)
#         print(form.content.data)
#         print(form.date.data)
#         flash('Data sucessfuly saved!')
#     return render_template('new.html', form=form)

app/templates/base.html
{% extends "bootstrap/base.html" %}

{# Block for Page Title #}
{% block title %}
    {% if title %}{{ title }}{% else %}.: Flask-Boilerplate :.{% endif %}
{% endblock title %}

{# Block for Head section #}
{% block head %}
    <link rel="icon" href="{{ url_for('static', filename='favicon.ico') }}" type="image/png">
    {{ super() }}
{% endblock head %}

{# Block for meta tags #}
{% block metas %}
    {{ super() }}
{% endblock metas %}

{# Block for CSS styles #}
{% block styles %}
    {{ super() }}
    <link rel="stylesheet" type="text/css"
          href="//cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='css/style.css') }}">
{% endblock styles %}

{# Block for JS scripts #}
{% block scripts %}
    {{ super() }}
    {{ moment.include_moment() }}
    <script src="{{ url_for('static', filename='js/app.js') }}"></script>
{% endblock scripts %}

{# Block for Navigation Bar #}
{% block navbar %}
    <nav class="navbar navbar-expand-lg navbar-expand-md navbar-light bg-light">
        <div class="container">
            {# Uncomment the line below to use an image as the NavBar Icon #}
            {#  <a class="navbar-brand" href="/"><img src="{{ url_for('static', filename='images/logo.png') }}"></a>#}
            <a class="navbar-brand" href="/">MySiteName</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent"
                    aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav mr-auto">
                    <li class="nav-item active">
                        <a class="nav-link" href="/">Home <span class="sr-only">(current)</span></a>
                    </li>
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button"
                           data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            Posts
                        </a>
                        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                            <a class="dropdown-item" href="#"><i class="fa fa-list"></i> List</a>
                            <div class="dropdown-divider"></div>
                            <a class="dropdown-item" href="#"><i class="fa fa-plus"></i> New</a>
                        </div>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link disabled" href="#">Disabled</a>
                    </li>
                </ul>
                {#      SEARCH FORM - BEGIN     #}
                {#    <form class="form-inline my-2 my-lg-0">#}
                {#      <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">#}
                {#      <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>#}
                {#    </form>#}
                {#      SEARCH FORM - END #}
                {#      SIMPLE PROFILE DROPDOWN - BEGIN #}
                {#    <ul class=""navbar-nav>#}
                {#    <!-- PROFILE DROPDOWN - scrolling off the page to the right -->#}
                {#        <li class="nav-item dropdown">#}
                {#            <a href="#" class="nav-link dropdown-toggle" id="navDropDownLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">#}
                {#        Profile#}
                {#            </a>#}
                {#            <div class="dropdown-menu" aria-labelledby="navDropDownLink">#}
                {#                <a class="dropdown-item" href="#">Preferences</a>#}
                {#                <div class="dropdown-divider"></div>#}
                {#                <a class="dropdown-item" href="#">Logout</a>#}
                {#            </div>#}
                {#        </li>#}
                {#    </ul>#}
                {#      SIMPLE PROFILE DROPDOWN - END #}
                <ul class="nav navbar-nav navbar-right">

                    {% if current_user.is_anonymous %}
                        <li><a href="{{ url_for('auth.login') }}">{{ _('Login') }}</a></li>
                    {% else %}
                        <li class="dropdown"><a href="#" class="dropdown-toggle" data-toggle="dropdown">
                        {{ current_user.username }}
                        {#                        Account#}
                        <b class="caret"></b></a>
                        <ul class="dropdown-menu">
                            <li>
                                <div class="navbar-content">
                                    <div class="row">
                                        <div class="col-md-5">
                                            <img src="{{ current_user.email|gravatar(size=120) }}"
                                                 alt="Alternate Text" class="img-responsive"/>
                                            {#                                            <p class="text-center small">#}
                                            {#                                                <a href="#">Change Photo</a></p>#}
                                        </div>
                                        <div class="col-md-7">
                                            <span>{{ current_user.name }}</span>
                                            <p class="text-muted small">{{ current_user.email }}</p>
                                            <div class="divider">
                                            </div>
                                            <a href="{{ url_for('main.user', username=current_user.username) }}"
                                               class="btn btn-primary btn-sm active">View Profile</a>
                                        </div>
                                    </div>
                                </div>
                                <div class="navbar-footer">
                                    <div class="navbar-footer-content">
                                        <div class="row">
                                            <div class="col-md-6">
                                                <a href="#" class="btn btn-default btn-sm">_('Change Password')</a>
                                            </div>
                                            <div class="col-md-6">
                                                <a href="{{ url_for('auth.logout') }}"
                                                   class="btn btn-default btn-sm pull-right">_('Logout')</a>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </li>
                        </ul>
                    {% endif %}
                    </li>
                </ul>

            </div>
        </div>
    </nav>
{% endblock navbar %}

{# Block for main content container #}
{% block content %}
    <div class="container">
        <div class="row">
            <div class="col col-12">
                <div class="title text-center h1 mb-4">{% block page_title %}Home{% endblock %}</div>
            </div>
        </div>
        {% with messages = get_flashed_messages(with_categories=true) %}
            {% if messages %}
                {% for category, message in messages %}
                    <div class="alert alert-{{ category }}" role="alert">
                        {{ message|safe }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                {% endfor %}
            {% endif %}
        {% endwith %}

        {# application content goes inside app_content block #}
        {% block app_content %}{% endblock app_content %}
    </div>
    <footer class="footer fixed-bottom bg-light border-top mt-4 ">
        <div class="container pt-2 footer-copyright text-center small">
            <span class="text-muted"><a href="//frederico.cf" class="text-primary">Frederico Freire Boaventura</a> <i
                    class="fa fa-copyright"></i> 2019-2019</span>
        </div>
    </footer>
{% endblock content %}

app/templates/edit_profile.html
{% extends "base.html" %}
{% import 'bootstrap/wtf.html' as wtf %}


{% block page_title %}
    {{ _('Edit Profile') }}
{% endblock page_title %}

{% block app_content %}
    <div class="row">
        <div class="col-md-4">
            {{ wtf.quick_form(form) }}
        </div>
    </div>
{% endblock %}

app/templates/index.html
{% extends "base.html" %}

{% block title %}Index{% endblock title %}

{% block page_title %}Index{% endblock page_title %}
{% block app_content %}
	<div class="row">
		<div class="span4">
			<img src="http://placehold.it/360x200" class="img-polaroid" alt="">
		</div>
		<div class="span4">
			<img src="http://placehold.it/360x200" class="img-polaroid" alt="">
		</div>
		<div class="span4">
			<img src="http://placehold.it/360x200" class="img-polaroid" alt="">
		</div>
	</div>
{% endblock app_content %}

app/templates/list.html
{% extends "base.html" %}
{% import "bootstrap/wtf.html" as wtf %}

{% block title %}Lista!{% endblock %}

{% block app_content %}

	<h1>Listagem</h1>
	
	<div class="row">
		<div class="span12">

			Listagem...

			<table class="table">
				<tr>
					<th>Coluna 1</th>
					<th>Coluna 2</th>
					<th>Coluna 3</th>
					<th>Coluna 4</th>
					<th>Coluna 5</th>
					<th>Coluna 6</th>
				</tr>
				<tr>
					<td>valor 1</td>
					<td>valor 2</td>
					<td>valor 3</td>
					<td>valor 4</td>
					<td>valor 5</td>
					<td>valor 6</td>
				</tr>
				<tr>
					<td>valor 1</td>
					<td>valor 2</td>
					<td>valor 3</td>
					<td>valor 4</td>
					<td>valor 5</td>
					<td>valor 6</td>
				</tr>
				<tr>
					<td>valor 1</td>
					<td>valor 2</td>
					<td>valor 3</td>
					<td>valor 4</td>
					<td>valor 5</td>
					<td>valor 6</td>
				</tr>
				<tr>
					<td>valor 1</td>
					<td>valor 2</td>
					<td>valor 3</td>
					<td>valor 4</td>
					<td>valor 5</td>
					<td>valor 6</td>
				</tr>
			</table>

		</div>
	</div>

{% endblock app_content %}

app/templates/new.html
{% extends "base.html" %}
{% import "bootstrap_wtf.html" as wtf %}

{%block title%}Novo!{%endblock%}

{%block main_content%}

	<h1>Novo</h1>
	<div class="row">
		<div class="span12">

			<form action="/save/" method="post" name="exampleform">
				{{ wtf.form_errors(form,"only") }}

				{{ form.hidden_tag() }}
				{{ wtf.horizontal_field(form.title) }}<br>
				{{ wtf.horizontal_field(form.content) }}
				{{ wtf.horizontal_field(form.date) }}
				{# wtf.horizontal_field(form.recaptcha) #}

				<div class="form-actions">
					<button name-"action_save" type="submit" class="btn btn-primary">Salvar</button>
				</div>
			</form>

		</div>
	</div>

{%endblock%}

app/templates/user.html
{% extends "base.html" %}

{% block page_title %}{% endblock page_title %}

{% block app_content %}
    <table class="table table-hover">
        <tr>
            <td><img src="{{ current_user.email|gravatar(size=256) }}" alt=""></td>
            <td>
                <h1>{{ _('User') }}: {{ user.username }}</h1>
                {% if user.name %}<p>{{ user.name }}</p>{% endif %}
                {% if user.about_me %}<p>{{ user.about_me }}</p>{% endif %}
                {% if user.last_seen %}
                    <p>{{ _('Last seen on') }}: {{ moment(user.last_seen).format('LLL') }}</p>
                {% endif %}
                {% if user == current_user %}
                <p>
                    <a href="{{ url_for('main.edit_profile') }}">{{ _('Edit your profile') }}</a>
                </p>
                {% else %}
                    <p>
                        <a href="{{ url_for('main.send_message', recipient=user.username) }}">{{ _('Send private message') }}</a>
                    </p>
                {% endif %}
            </td>
        </tr>
    </table>
{% endblock app_content %}